﻿/*******************************************************************
	AviUtl リロード プラグイン 用再起動ヘルパー

	By NightWork
 *******************************************************************/

 /*------------------------------------------------------------------
	実行中のAviUtlのPID、AviUtlのパス、編集中プロジェクトファイルのパスを受け取り
	旧プロセス終了後に新しくAviUtlを起動する。

 ------------------------------------------------------------------*/


#include <stdio.h>
#include <stdlib.h>
#include <windows.h>
#include <synchapi.h>


 /*------------------------------------------------------------------
    global variables
    グローバル変数
  ------------------------------------------------------------------*/
char aviutl_exe_path[FILENAME_MAX];		//AviUtl本体のパス
char aviutl_exe_pid[8];				//AviUtlのPID
char project_path[FILENAME_MAX];		//プロジェクトファイルパス



/*------------------------------------------------------------------
   メイン
 ------------------------------------------------------------------*/
int WINAPI WinMain(
	HINSTANCE hInstance,
	HINSTANCE hPrevInstance,
	LPSTR lpCmdLine,
	int nCmdShow)
{
	//変数初期化
	STARTUPINFO si;
	PROCESS_INFORMATION pi;
	char buf[520];			//コマンドラインバッファ
	int ret;			//リターンコード
	HANDLE hProcess;		//旧AviUtlハンドル
	ZeroMemory(&si, sizeof(si));


	//引数取得
	snprintf(aviutl_exe_pid, 8, "%s", __argv[1]);			//PID
	snprintf(aviutl_exe_path, FILENAME_MAX, "%s", __argv[2]);	//AviUtl本体
	snprintf(project_path, FILENAME_MAX, "%s", __argv[3]);		//プロジェクトファイル


	//旧プロセス終了待機
	hProcess = OpenProcess(SYNCHRONIZE | PROCESS_VM_READ, FALSE, atoi(aviutl_exe_pid));
	WaitForSingleObject(hProcess, INFINITE);
	CloseHandle(hProcess);
	Sleep(500);	//保険


	//コマンドライン結合
	snprintf(buf, 520
		, "%s\ \"%s\""
		, aviutl_exe_path
		, project_path);


	//AviUtl再起動
	ret = CreateProcessA(NULL		// 実行可能モジュールの名
		, buf				// コマンドラインの文字列
		, NULL				// セキュリティ記述子
		, NULL				// セキュリティ記述子
		, FALSE				// ハンドルの継承オプション
		, NULL				// 作成のフラグ
		, NULL				// 新しい環境ブロック
		, NULL				// カレントディレクトリの名前
		, &si
		, &pi);

	CloseHandle(pi.hProcess);
	CloseHandle(pi.hThread);

	return ret;
}